/*******************************************************************
 * vxipc.h      -- include file for VxWorks ipc commands           *
 * author:   C. Timmermans, University of Michigan                 *
 *******************************************************************/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
#if defined(VXWORKS) && !defined(IPC_CREAT)
#define  IPC_CREAT    0001000         /* create entry if key doesn't exist */
#define  IPC_EXCL     0002000         /* fail if key exists */
#define  IPC_NOWAIT   0004000         /* error if request must wait */

   /* Keys. */
#define  IPC_PRIVATE  (key_t)0        /* private key */

   /* Control Commands. */
#define       IPC_RMID        0       /* remove identifier */
#define       IPC_SET         1       /* set options */
#define       IPC_STAT        2       /* get options */

#define       IPC_ALLOC       0100000         /* entry currently allocated */
#define     IPC_LOCKED      0040000         /* structure is locked */
#define     IPC_WANTED      0004000         /* process waiting for lock */

#define SHM_RDONLY      010000  /* attach read-only (else read-write) */
#define SHM_RND         020000  /* round attach address to SHMLBA */

struct shmid_ds {
  int              shm_segsz;      /* size of segment in bytes */
  int            shm_lpid;       /* pid of last shmop */
  int           shm_cpid;       /* pid of creator */
  unsigned short int shm_nattch;   /* current # attached (accurate) */
  unsigned short int shm_cnattch;  /* in memory # attached (inaccurate) */
};

#endif
