/*******************************************************************
 * status_path.c      -- status path, version 0.2                  *
 * author:   C. Timmermans, University of Michigan                 *
 *******************************************************************/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
#ifdef VXWORKS
#include <semLib.h>
#else
#define SEM_ID  int
#endif

#define SP_FREE        1
#define SP_LOCK        -1

#define FIRST_SP_KEY   201
#define MAX_SP          30

#define SP_MAXCHAR     150

#define MAX_DB_PROC    20
#define NR_DB_BUFF     20
#define DB_BUFF_SIZE   40000
#define B_SIZE         (DB_BUFF_SIZE/NR_DB_BUFF)

struct data_pointer{
  short *p_size;
  short *p_type;
  char *p_crit;
  char *p_var;
  char *p_val;
  char *p_last;
};

struct data_buffer {
  int proc;           /* points back to the process, 
				NULL when not used */
  int b_first;        /* points to the first address of this buffersegment */
  int b_last;         /* points to the last address of this buffersegment */
  int next;           /* points to next data_buffer controlled by
				the same process, NULL when not used */
};

struct proc_entry {
  char name[15];             /* process name or empty when not used */
  int first;                 /* points to the first buffer linked to process,
				NULL when not used */
};

struct status_path {
  int empty_segments;          /* the number of empty buffer segments */
  int empty_proc_entry;        /* the number of empty proc entry structures */
  SEM_ID sp_lock;
  char buffer[DB_BUFF_SIZE];   /* buffer space to store data */
  struct proc_entry proc_info[MAX_DB_PROC]; /*links process names to buffers */
  struct data_buffer buf_info[NR_DB_BUFF];  /* tells which buffers are used */
};
