/*************************************************
 * CVS Log
 * mur_user.h,v
 * Revision 1.1.1.1  1993/07/14  19:43:20  dbrenner
 * UNIDAQ 2.1 distribution - July 14,1993
 *
*************************************************/
#ifndef MUR_USER_HEADER
#define MUR_USER_HEADER
/* ==========================================================================
**
** MUR_USER.H
**
** DESCRIPTION
**	This "C" include file contains all necessary definitions and macros
**	for applications using the MURMUR client library.
**
** DEVELOPERS
**	Gary P. Sergey
**
**	Fermilab Data Acquisition Group
**	Batavia, Il 60510, U.S.A.
**
** MODIFICATIONS
**         Date       Initials	Description
**	18-Feb-1992	GPS	Original Entry
** 
*/
#include "mur_cond.h"     /* MURMUR conditional directives */
#include "mur_macros.h"   /* MURMUR message code macros */

/*===========================================================================
**
** 	MUR_ARG_TYPE - MURMUR MESSAGE ARGUMENT TYPES (ENUMERATED)
** 
** This enumeration identifies the variable types that are allowed to be
** passed as arguments to the MURMUR message send routine (mur_send).
*/

typedef enum
   {
   MUR_NOTYPE=0,	/* No message argument (must equal 0) */
   MUR_LONG,		/* Longword integer argument */
   MUR_U_LONG,		/* Unsigned longword integer argument */
   MUR_FLOAT,		/* Single precision floating point argument */
   MUR_STRING,		/* Character string argument */
   MUR_APPEND,		/* Appended text string argument */
   MUR_TEXT_ONLY_MSG	/* Text only string */
   } MUR_ARG_TYPE;

typedef unsigned char MUR_ARG_TYPE_BYTE;


/*===========================================================================
**
** 	PROTOTYPES FOR USER CALLABLE ROUTINES AND MACRO DEFINITIONS
*/

unsigned long mur_send MUR_PROTO((unsigned long, int, ...));
unsigned long mur_set_proc_name MUR_PROTO((char *));
unsigned long mur_send_text MUR_PROTO((char *));
unsigned long mur_translate_vms MUR_PROTO((unsigned long, unsigned long *));
unsigned long mur_translate_unix MUR_PROTO((int, unsigned long *));
unsigned long mur_open();

#ifdef MUR_VXWORKS
void mur_server_add MUR_PROTO((char *));
void mur_route_send MUR_PROTO((...));
void mur_route_start();
#endif

#define mur_route_send_text(a_text) mur_route_send(0,1,MUR_TEXT_ONLY_MSG, (a_text))
#endif
