%{
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <strings.h>

extern	char facility_name[];
extern	int facility_number;
extern char	message_mnemonic[];
extern char *sys_errlist[];
extern int sys_nerr;

#define TRUE  1
#define FALSE 0
#define MAX_BASE 500

extern void clrstr();
extern void yyerror();
extern int  yylex();
int yyparse();

struct base_element {
	char * base_name;
	int base_value;
	};

extern int current_base;
extern struct  base_element baselist[];

int mur_find_base(s)
	char *s;
	{
	int i;
	   
	   for (i=0; i< current_base;i++)
	      if (strcmp(baselist[i].base_name,s) == 0)
		 return(baselist[i].base_value);
/*
** base not found
*/
	   return(-1);
	}

void mur_add_base(s,n)
	char *s;
	int n;
	{
	   if ( current_base<MAX_BASE)
	      {
	      baselist[current_base].base_name = malloc(strlen(s)+1);
	      sprintf(baselist[current_base].base_name,"%s",s);
	      baselist[current_base].base_value = n;
	      current_base++;
	      }
	   else
	      {
	      yyerror("\n*** Message Base list FULL !!! Aborting Program\n");
	      exit(0);
	      }
	}


extern	char keystring[];
extern	char txtstring[];
extern	char commentstring[];
extern	char sevstring[];
extern	char color[];
extern  char trailingcomment;
extern  int 	base;
extern int	message_number;	/* message number generated from the base */
extern  char yytext[];
extern  char inputline[];

char	severity[2];
char	prefix_name[256];
char	filename[256];
char	tmp_txtstring[256];

int 	nofacility = TRUE;
int	message_code;	/* encoded message code including facility,severity, */
			/* and message number */
int	severity_number;
int	number_items = 0;
int 	i = 0;
int	sev;
%}

%start line
%union {
	int int_val;	
	char *char_ptr;
	}

%token <char_ptr> COMMENT
%token <char_ptr> ID
%token <int_val>  HEXNUMB
%token <int_val>  OCTNUMB
%token <int_val>  DECNUMB
%token <int_val>  DEFINE 
%token <int_val> LEFT_PAREN
%token <int_val> RIGHT_PAREN
%token <int_val> PLUS
%token <int_val>  BLANKLINE
%token <int_val>  BASE
%token <int_val>  IGNORE
%token <int_val>  OOPS
%token <int_val>  ENDMARKER	0

%type <int_val> msg_expression
%type <int_val> number
%%

line 	: /* empty line */ {return (BLANKLINE);}
	|	msg_expression  
	|	comment 	
	;

msg_expression  : 	DEFINE 	ID	number	COMMENT
			{			
			   sprintf(message_mnemonic,"%s",$<char_ptr>2);
			   strncpy(txtstring,&commentstring[2],
				strlen($4)-4);
			   txtstring[strlen($4)-4] = '\0';
			   message_number = $3;
			   mur_add_base($<char_ptr>2,message_number);
			   return(ID);
			}
		|	DEFINE 	ID LEFT_PAREN  number PLUS ID RIGHT_PAREN COMMENT
			{
			   base = mur_find_base($<char_ptr>6);
			   if (base != -1)
			   {
			      strncpy(txtstring,&commentstring[2],
				      strlen($8)-4);
			      txtstring[strlen($8)-4] = '\0';
			      sprintf(message_mnemonic,"%s",$<char_ptr>2);
			      message_number =  base +$<int_val>4;
			      mur_add_base($<char_ptr>2,message_number);
			      return(ID);
			   }
			   else
			   {
			      yyerror("Can't find base for message !");
			      return(OOPS);
	   		   }
			}
		|	DEFINE	ID LEFT_PAREN  ID PLUS number RIGHT_PAREN COMMENT
			{
			   base = mur_find_base($<char_ptr>4);
			   if (base != -1)
			   {
			      strncpy(txtstring,&commentstring[2],
				      strlen($8)-4);
			      txtstring[strlen($8)-4] = '\0';
			      sprintf(message_mnemonic,"%s",$<char_ptr>2);
			      message_number =  base +$<int_val>6;
			      mur_add_base($<char_ptr>2,message_number);
			      return(ID);
			   }
			   else
			   {
			      yyerror("Can't find base for message !");
			      return(OOPS);
	  		   }
			}
		|	DEFINE	ID	ID
			{
			   
			   base = mur_find_base($<char_ptr>3);
			   if (base != -1)
		 	   {
			      mur_add_base($<char_ptr>2,base);
			   }
			   else
			   {
			       yyerror("Can't find base ID !!!");
			       return(OOPS);
			   }
			   return(BASE);
			}
		|	DEFINE	ID	number
			{
			   mur_add_base($<char_ptr>2,$3);
			   return(BASE);
			}
		|	DEFINE  ID 
			{
			   mur_add_base($<char_ptr>2,999);
			   return(IGNORE);
			}
		;

comment 	: 	COMMENT
			{
			strncpy(txtstring,&commentstring[2],strlen($1)-4);
			txtstring[strlen($1)-4] = '\0';
			return (COMMENT);
			}
		;

number		:	DECNUMB 			
		|	HEXNUMB 
		|	OCTNUMB 
		;
