/*************************************************
 * CVS Log
 * mur_generrtab.c,v
 * Revision 1.1.1.1  1993/07/14  19:43:23  dbrenner
 * UNIDAQ 2.1 distribution - July 14,1993
 *
*************************************************/
/*************************************************************************

	mur_generrtab.c is the murmur facility unix message conversion utility.
It takes as the system errno.h file, parses it and generates unix message 
records to be loaded  into the specified  database.  

*************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#ifdef MUR_IRIX
#include <getopt.h>
#endif 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>
#include <strings.h>
#include <time.h>
#include "yERR.tab.h"
#include "murmur_msg_c.h"
#include "errno_msg_c.h"

#define TRUE 1
#define FALSE 0
#define MAX_BASE  500

struct base_element {
	char *base_name;
	int base_value;
	};

/* For getopt. */
extern char *optarg;

extern int optind, opterr;

int current_base=0;
struct base_element baselist[500];

char *idlist[5];
int currentid = 0;

char hexstring[256], keystring[256], txtstring[BUFSIZ], idstring[256];
char octstring[256], decstring[256],sevstring[10], groupstring[256];
char commentstring[BUFSIZ], helpfile[256],color[14];
char inputline[BUFSIZ];
char EOL = FALSE;
char dumpobj =FALSE;

char error_text[500];
char facility_name[256];
int  facility_number = 0;
int  base = 1;
int  message_number=1;
char trailingcomment = FALSE;
char listing  = TRUE;
char  error_flag  = FALSE;
int  error_count = 0;

extern char *sys_errlist[];
extern int sys_nerr;
char message_mnemonic[32];
FILE *errdesc, *errtabdesc;	/* file descriptors */
FILE  *msgdesc;

unsigned long status;

int yyparse();
int yywrap();
void upcpy();
void yyerror();
void clrstr();
#ifdef MUR_SUNOS
int strcasecmp();
#endif

int 
	yywrap()
		{
		return 1;
		}

void 
	usage (s) 
	char *s;
	{
  	   printf(
	      "Usage: %s \nor     %s  [errno_file]\n",s,s);
	   exit (2);
	}

void 	mur_getline(s)
	char *s;
	{
        int c;
	   
	   c = getc(msgdesc);
	   while (c != '\n' && !feof(msgdesc))
	      {
	      *s++ = c;
	      c = getc(msgdesc);
	      }
	}

void 
	clrstr( s)
	char *s;
        {
		while (*s != '\0'){
			*s++ = '\0';
			}
	}

void 
	upcpy(mine, old)
	char *mine;
	char *old;
	{
	register int c;
 	while (c = (int) *old++) {
		*mine++ = islower(c)?toupper(c):c;
		}
	*mine = 0;
	}


/* The test program blah blah blah 
   information.  See the help command (?) for a list of all commands. */

main (argc,argv)
int argc;
char *argv[];
{

int opt;
time_t create_time;
char	*timeout;
char  nocasecheck = FALSE;
char  notfound = TRUE;
char  filename[256];
char errtabfile[256];		/* listing file */
char msgfile[256];
char mnemonic[17];
unsigned long msg_code;
char *ext;

char rootdir[256];
int rootlen;
int filelen;
int msg_count =0;	/* maintain a count of messages generated */
int line_number = 0;	/* line number maintained for listing file */
int token;	/* parser token to determine msg utility action */
int nbytes;
int last_message_number=0; 
int i;

/* Initialization */

   if (argc > 2)
      {
      printf("\nToo many input parameters\n");
      usage(argv[0]);
      }
   else if (argc == 2)
      {
      errdesc = freopen(argv[1], "r", stdin);
      sprintf(filename,"%s",argv[1]);
      }
   else 
      {
      errdesc = freopen("/usr/include/sys/errno.h", "r", stdin); 
      sprintf(filename,"%s","/usr/include/sys/errno.h");
      }

   if (errdesc == NULL )
      {
      perror(argv[optind]);
      exit(-1);
      }

/*
** get product root directory from mur_generrtab location
*/
   rootlen = strlen(argv[0])- strlen(strstr(argv[0],"/bin"));
   strncpy(rootdir,argv[0],rootlen);
   rootdir[rootlen] = '\0';

   sprintf(errtabfile,"%s/include/mur_errtab.h",rootdir);
   errtabdesc = fopen(errtabfile, "w");
   if (errtabdesc  == NULL)
      {
      perror(errtabfile);
      exit(-1);
      }


   sprintf(msgfile,"%s/include/errno_msg_c.h",rootdir);
   msgdesc = fopen(msgfile, "r");
   if (msgdesc == NULL )
      {
      perror(msgfile);
      exit(errno);
      }

/* write  creation headers */
   time(&create_time);
   timeout = ctime(&create_time);
   fprintf(errtabdesc,
      "#ifndef MUR_ERRTAB_HEADER\n#define MUR_ERRTAB_HEADER\n");
   fprintf(errtabdesc,
"/*************************************************************************\n");
   fprintf(errtabdesc,
      "**\n**\tMURMUR Error Message Definition Table of Unix Errors\n**\n");
   fprintf(errtabdesc,
      "** Messages are generated from : %s\n",filename);
   fprintf(errtabdesc,"**\n");
   fprintf(errtabdesc,
   "** This table is generated once per platform (SunOS, IRIX,\n");
   fprintf(errtabdesc,"** AIX, ULTRIX).\n");
   fprintf(errtabdesc,
"*************************************************************************/\n");

#ifndef MUR_VXWORKS
   fprintf(errtabdesc,
      "\nunsigned long mur_errnoTbl[] = {\n");
#else
   fprintf(errtabdesc,
      "\nunsigned long mur_errnoTbl[] = {\n");
#endif

   fprintf(errtabdesc,"\t0X%X     /*  %s  */",errno_UNKNOWN,
          "Unknown UNIX System error message");

/*
**	Begin parsing and file generation loop 
*/

   clrstr(keystring);
/*
** read  until  end of file or sys_nerr exhausted
*/
   while (!feof(errdesc) && (last_message_number < sys_nerr-1))
   {

next_token:

      clrstr(inputline);
      token = yyparse();
      if (token == ID)
      {
/*
** fill in empty errno codes
*/

	fprintf(errtabdesc,",\n");
	if ( (message_number - last_message_number) > 1)
	   for (i=last_message_number+1; i< message_number; i++)
	      fprintf(errtabdesc,"\t0X%X     /*  %s  */,\n",errno_UNKNOWN,
		      "Unknown UNIX System error message");

/*
** get translated message code from errno_msg_c.h file
*/
	notfound = TRUE;
        while (notfound && !feof(msgdesc))
           {
	   clrstr(inputline);
	   mur_getline(inputline);
           if (strncmp(inputline,"#define",7)== 0)
	      {
	      status = sscanf(inputline,"#define errno_%s 0X%X \n",
			      mnemonic,&msg_code);
	      if (status == 2)
	         {
    	         if (strcmp(message_mnemonic,mnemonic) == 0)
	            {
		    fprintf(errtabdesc,"\t0X%X     /* %s  */",
                            msg_code,txtstring);
	            notfound = FALSE;
         	    goto msg_found;
 	            }
		 }
              }
           }
/* 
** Unrecognized message set UNKNOWN status in the table
*/
msg_notfound:

	if (notfound) 
	   {
	   printf("errno msg - %s - NOT FOUND in errno.msg \n",
		  message_mnemonic);
	   printf("Contact your MURMUR CONSULTANT\n");
	   fprintf(errtabdesc,"\t0X%X     /*  %s  */",errno_UNKNOWN,
                   "Unknown UNIX System error message");
	   }
msg_found:

	last_message_number = message_number;
	rewind(msgdesc);
      } /* end ID */

/*
**	reset id list for next list of message id definitions
*/
      for (i=0; i<currentid; i++);
	{
	if (idlist[i] != NULL)
	   {
	   free(idlist[i]);
	   idlist[i] = NULL;
	   }
	}
      currentid = 0;

   }  /* end while loop */

/*
** write ending command
*/
  fprintf(errtabdesc,"\n\t};\n\n");
  fprintf(errtabdesc,
  "long int MUR_ERRTABSIZE = sizeof(mur_errnoTbl)/sizeof(mur_errnoTbl[0]);\n\n");
  fprintf(errtabdesc,"#endif\n");

/*
** check for proper loop termination i.e. feof(errdesc)
*/
  if (last_message_number >= sys_nerr)
     {
     printf("\n\t*** mur_errtab.h created is INVALID *** \n");
     printf("\t*** errno.h messages exceed sys_nerr maximum (%d)! ***\n\n",
	    sys_nerr);
     }


/* Quit normally. */

  fclose(errtabdesc);
  fclose(msgdesc);
  fclose(errdesc);
  exit (0);
}

void
yyerror(s) 
char *s;
{	
	extern int yylineno;
	extern char yytext[];
	extern char listing;
	extern char error_flag;
	extern char inputline[];
	extern  int error_count;
	extern  char error_text[];

	error_count++;
	fprintf(stderr,"***lineno: %d - %s\n",yylineno, inputline);
	fprintf(stderr,"%s\n",s);
	fprintf(stderr,"%s\n",yytext);
	sprintf(error_text,"%s, token: %s",s,yytext);
	error_flag = 1;
}
