/* /////////////////////////////////////////////////////////////////
//
// file:    operator.C
// author:  C. Timmermans
// version: 2.0
// date:    3/09/93
///////////////////////////////////////////////////////////////// */

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <string.h>
#include <strings.h>
#include <time.h>
#include <sys/time.h>

#define MSG_STOR   1
#define MSG_RUN    2
#define MSG_PROMPT 4

extern char prompt_str[50];
extern char prompt_proc[50];
extern int message_mask;

extern struct timeval t_getdata;
extern struct timeval t_getstor;


void Init_Process(argc,argv)
int argc;
char **argv;
{
  Crit_Var("runcontrol");
}

/* /////////////////////////////////////////////////////////////// */
int Process_Event(string)
char *string;
/* //////////////////////////////////////////////////////////////
// Receives all kind of messages and react to them
///////////////////////////////////////////////////////////// */
{
	char temp1[100],temp2[100],cmd[50],arg[100];

#ifdef _DEBUG
	printf("Received command: %s\n",string);
#endif
	Parse(string,temp1,temp2);
	Parse(temp2,cmd,arg);
	if(strcasecmp(cmd,"QUERY_RUNPAR") == 0) Query_Runpar();
	else if(strcasecmp(cmd,"QUERY_STORAGE") == 0) Query_Storage();
	else if(strcasecmp(cmd,"prompt") == 0) Prompt(temp1,arg);
	else return(-1); 
	return(0);
}
void No_Event()
{

	Execute_screen();
        gui_wait(1);
 }

void Exit_Process()
{

}

int Query_Runpar()
{
  t_getdata.tv_sec = 0;
  Execute_screen();
  message_mask = message_mask | MSG_RUN;
}

int Query_Storage()
{
  t_getstor.tv_sec = 0;
  Execute_screen();
  message_mask = message_mask | MSG_STOR;
}

int Prompt(proc,s)
char *proc,*s;
{
  strcpy(prompt_str,s);
  strcat(prompt_str," ");
  strcpy(prompt_proc,proc);
  message_mask = message_mask | MSG_PROMPT;
}

