/*****************************************************
 * FILE: runcon.h
 * Author: C. Timmermans, University of Michigan
 *****************************************************/
#include<stdlib.h>

/********************************************************
  Please enter the action routines here. These routines descrbe
  the action taken when clicking a button. At this point 
  they should be added as:
            extern int routine();
  The coding for these routines should be done in file 
  runcon_act.c. This file contains the information on how to 
  write these routines and some examples.
 ********************************************************/
extern int act_cold();
extern int act_warm();
extern int act_stop();
extern int act_cont();
extern int act_pause();
extern int act_dwnld();
extern int act_init();


struct rc_def rc_but[] = {
/**********************************************************
  For each button, the defining fields must be entered below. 
  Each field has 2 entries, ordered as follows:
  char txt[20];     Comment to display on the button
  int (*action)();  Action taken when button is clicked. These 
                    routines should be entered as:
		    (int (*)())routine
 ************************************************************/
  "Start cold", (int (*)())act_cold ,
  "Start warm", (int (*)())act_warm ,
  "Continue"  , (int (*)())act_cont ,
  "Suspend"   , (int (*)())act_pause,
  "Stop"      , (int (*)())act_stop ,
  "Initialize", (int (*)())act_init ,
  "Download"  , (int (*)())act_dwnld,
};


/**********************************************************
  The MAX_N_RC_BUT definition determines the maximum number of
  buttons that can be displayed. This number should be at least equal
  to the number of parameter displays you have defined above.
 ***********************************************************/
#define MAX_N_RC_BUT 10

int n_rc_but = sizeof(rc_but)/sizeof(struct rc_def);

