/*************************************************
 * hmapi.c,v
*************************************************/
/*CMZ :  4.14/02 02/03/92  18.28.09  by  Rene Brun*/
/*-- Author :    Fons Rademakers   20/03/91*/
/*-- Modified:   Wojtek Burkot     02/03/92*/

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

int  shm_pawc;
long len;

int hmapi_(mkey, comaddr)
/*
 * mkey          identifier for the shared segment
 * comaddr       required starting address of mapping in input
                 starting address of the mapping (*)
 *               (*) = output variables
 */
long  *comaddr;
key_t *mkey;
{
   int             istat;
   unsigned long   inter;
   char            *paddr, *req_addr, *shmat();
   struct shmid_ds shm_stat;

   /* get id of existing shared memory segment */
   if ((shm_pawc = shmget(*mkey, 0, SHM_R | SHM_W)) < 0) {
      perror("shmget");
      istat = -errno;
      return(istat);
   }

   /* get size of shared memory segment */
   if (shmctl(shm_pawc, IPC_STAT, &shm_stat) == -1) {
      perror("shmctl");
      istat = -errno;
      return(istat);
   }
   len = shm_stat.shm_segsz;
   printf("length of mapped memory=%d\n",len);
  /* set required mapping address -actual mapping addres depends on
     setting of system variables. This requires modification in
     the interface fortran routine HMAPM
   */
   req_addr=(char*)(*comaddr);
/*   printf("req_addr=%d",(unsigned) req_addr);*/
   /* attach shared memory segment */
   if ((paddr = shmat(shm_pawc, req_addr, SHM_RND)) == (char *)-1) {
      perror("shmat");
      istat = -errno;
   } else {
      istat    = 0;
      inter = (long) paddr;
      *comaddr = (unsigned) inter >> 2;
   }
   return(istat);
}


