#!/usr/local/wish -f
#
# Unidaq configuration program for TCL/TK option -- uni_config.tcl
#


# Set the path for access to .tcl files
# set auto_path "$USERUNIDAQ/conf $auto_path"

set width 600
set h 150
wm title . "UNIDAQ configuration"
wm minsize . $width $h
wm maxsize . $width $h
# following doesn't like $width and $h 
wm geometry . 600x150

set vxtop ""
set vxuser ""

#-------------------------------------------------------
# The top of the screen will have a general message, some general
# information, and the main menu.
#-----------------------------------------------------
frame .topFrame -borderwidth 1 -relief raised
message .topFrame.msg -font -Adobe-times-medium-r-normal--*-180* \
             -relief raised -borderwidth 1 \
             -text "UNIDAQ PORTABLE DATA ACQUISITION SYSTEM" \
             -foreground white -background blue -width $width
message .topFrame.msg1 -font -Adobe-times-medium-r-normal--*-180* \
             -relief raised -borderwidth 1 -text "Configuration Process" \
             -foreground white -background blue -width $width

#-------------------------------------------------------------------
# Ensure an EDITOR is set
#-------------------------------------------------------------------
set iefnd 0
foreach ie [array names env] {
  if {($ie == "EDITOR")} {
     set iefnd 1
  }
}
if {($iefnd == "0")}  {
  puts stdout "No EDITOR is defined.  Please set one"
  puts -nonewline stdout "   Text Editor pathname >> "
  gets stdin edt
  set env(EDITOR) $edt
} else {
  set edt $env(EDITOR)
}
#-------------------------------------------------------------------
# The top of the screen is followed by a menu
#-------------------------------------------------------------------
menubutton .topFrame.net -text "Network" -menu .topFrame.net.m 
menubutton .topFrame.prog -text "Programs" -menu .topFrame.prog.m 
button .topFrame.edt -text "Editor" -command { ask_editor }
button .topFrame.butExit -text "Exit" -background red \
             -command {destroy .} -width 7

menu .topFrame.net.m
.topFrame.net.m add command -label "Nodefile" -command { \
	exec $edt $env(USERUNIDAQ)/conf/nodefile }
.topFrame.net.m add command -label "Start scripts" -command { \
	Display_start_stuff }

proc Display_start_stuff { } {
  global width node_number env flag Start_script Start_type
  catch { destroy .strt }
  toplevel .strt
  wm title .strt "Start_file editor"
  message .strt.msg -font -Adobe-times-medium-r-normal--*-180* \
             -relief raised -borderwidth 1 \
             -text "          UNIDAQ PORTABLE DATA ACQUISITION SYSTEM          " \
             -foreground white -background blue -width $width
  message .strt.msg1 -font -Adobe-times-medium-r-normal--*-180* \
             -relief raised -borderwidth 1 -text "Start files" \
             -foreground white -background blue -width $width
  set ptr [open $env(USERUNIDAQ)/conf/nodefile]
  set node_number 0
  pack .strt.msg -side top -fill both
  pack .strt.msg1 -side top -fill both
  while { [gets $ptr nde_type] > 0 } {
    incr node_number
    set type_indx [string first " " $nde_type]
    incr type_indx
    set Start_type($node_number) [string range $nde_type $type_indx end]
    incr type_indx -2
    set nde [string range $nde_type 0 $type_indx]
    set Start_script($node_number) $env(USERUNIDAQ)/conf/Start_$nde
    checkbutton .strt.n$node_number -text "Start_$nde" -onvalue "1" \
             -variable flag($node_number) -relief flat
    pack .strt.n$node_number -side top -expand yes -anchor w
  }
  button .strt.edt -text "Edit file" -command edt_start
  button .strt.no -text "Exit" -command " destroy .strt" -background red \
       -foreground white
  pack .strt.edt .strt.no -side left -expand yes -fill both -anchor w
}

proc edt_start { } {
  global env edt flag node_number Start_script Start_type vxtop vxuser

  set i 1
  while { $i <= $node_number } {
    if { $flag($i) == 1 } {
      if { [file exists $Start_script($i)] == 0 } {
        set strt_ptr [open $Start_script($i) w]
        if { [string compare [string tolower $Start_type($i)] unix] == 0 } {
          puts $strt_ptr "#!/bin/csh"
          puts $strt_ptr "onintr -"
          puts $strt_ptr "source \$USERUNIDAQ/setup.csh"
          puts $strt_ptr "msg_server >& /dev/null &"
          puts $strt_ptr "xpc >& /dev/null &"
        } else {
          vxvarframe
          set tmpstr "cd \""
          append tmpstr $vxuser
          append tmpstr "/conf\""
	  puts $strt_ptr $tmpstr
	  puts $strt_ptr "ld <vxshm.o"
          set tmpstr "cd \""
          append tmpstr $vxtop
          append tmpstr "/NOVA/src\""
	  puts $strt_ptr $tmpstr
	  puts $strt_ptr "ld <vxnovad"
	  puts $strt_ptr "cd \"../netsrc\""
	  puts $strt_ptr "ld <vxnovand"
	  puts $strt_ptr "cd \"../../bin\""
	  puts $strt_ptr "sp novad_main, \"dummy\""
	  puts $strt_ptr "sp novand_main"
	  puts $strt_ptr "ld <msg_server"
	  puts $strt_ptr "sp msg_server"
	  puts $strt_ptr "ld <status"
	  puts $strt_ptr "ld <repair"
	  puts $strt_ptr "ld <ask"
        }
        close $strt_ptr
      }
      exec $edt $Start_script($i)
      set flag($i) 0
    }
    incr i
  }
}

#
#  Put up a frame to request the vxworks topunidaq and userunidaq locations.
#
proc vxvarframe {} {
  global vxtop vxuser .strt width vxtopin vxuserin vxtopsave vxusersave

  set vxtopsave $vxtop
  set vxusersave $vxuser

  frame .strt.vxvar
  message .strt.vxvar.msg -font -Adobe-times-medium-r-normal--*-180* \
             -relief raised -borderwidth 1 -text "VxWorks UNIDAQ Locations" \
             -foreground white -background blue -width $width

  frame .strt.vxvar.topu
  addrunp .strt.vxvar.topu "VxWorks TOPUNIDAQ: " vxtop .33 1
  frame .strt.vxvar.useru
  addrunp .strt.vxvar.useru "VxWorks USERUNIDAQ: " vxuser .33 1

  frame .strt.vxvar.input
  label .strt.vxvar.input.cl1lab -text "VxWorks TOP >> " -foreground black \
        -background yellow
  entry .strt.vxvar.input.cl1input -relief raise -background white \
        -textvariable vxtopin -foreground black -borderwidth 1 -width 10

  label .strt.vxvar.input.cl2lab -text "VxWorks USER >> " -foreground black \
        -background yellow
  entry .strt.vxvar.input.cl2input -relief raise -background white \
        -textvariable vxuserin -foreground black -borderwidth 1 -width 10

  button .strt.vxvar.input.ok -text "OK" -command { vxokbut }
  button .strt.vxvar.input.cancel -text "CANCEL changes" -background red \
             -command { vxcancelbut } 

  place .strt.vxvar.msg -relx 0. -rely 0. -relwidth 1. -relheight 0.2
  place .strt.vxvar.topu -relx 0. -rely 0.21 -relwidth 1. -relheight 0.15
  place .strt.vxvar.useru -relx 0. -rely 0.37 -relwidth 1. -relheight 0.15

  place .strt.vxvar.input -relx 0. -rely 0.53 -relwidth 1.0 -relheight 0.5
  place .strt.vxvar.input.cl1lab   -relx 0.   -rely 0.0 -relwidth 0.28 \
         -relheight 0.30
  place .strt.vxvar.input.cl1input -relx 0.28 -rely 0.0 -relwidth 0.72 \
         -relheight 0.30
  place .strt.vxvar.input.cl2lab   -relx 0.   -rely 0.32 -relwidth 0.28 \
         -relheight 0.30
  place .strt.vxvar.input.cl2input -relx 0.28 -rely 0.32 -relwidth 0.72 \
         -relheight 0.30
  place .strt.vxvar.input.ok     -relx 0.  -rely 0.64 -relwidth 0.5 \
         -relheight 0.30
  place .strt.vxvar.input.cancel -relx 0.5 -rely 0.64 -relwidth 0.5 \
         -relheight 0.30

  bind .strt.vxvar.input.cl1input <KeyPress-Return> { cl1line }
  bind .strt.vxvar.input.cl2input <KeyPress-Return> { cl2line }

  place .strt.vxvar -relx 0. -rely 0. -relwidth 1. -relheight 1.
  grab set .strt.vxvar.input

  tkwait window .strt.vxvar
}

proc cl1line {} {
  global vxtop vxtopin
  set vxtop $vxtopin
  set vxtopin ""
}

proc cl2line {} {
  global vxuser vxuserin
  set vxuser $vxuserin
  set vxuserin ""
}

proc vxokbut {} {
  global vxuser vxtop vxusersave vxtopsave
  destroy .strt.vxvar
}

proc vxcancelbut {} {
  global vxuser vxtop vxusersave vxtopsave
  set vxuser $vxusersave
  set vxtop $vxtopsave
}
  
#        addrunp: Stolen fair and square from operator.tcl
#
# To make things easier, procedure addrunp is used to add runparameters to 
# the display. The arguments are:
# addrunp windowname label-text variable-name relative-label-size 1/0 
# a 1 means that the argument can be modified by user
#
proc addrunp { a atext avar lsiz uvar } {
    label $a.lab -text "$atext" -foreground white -background blue -anchor w
    if { $uvar == 1} {
        entry $a.ent -relief raise -background white -textvariable $avar \
	             -foreground black -borderwidth 1 -width 10
    } else {
        label $a.ent -relief raise -background blue -textvariable $avar \
	             -foreground white -borderwidth 1 -width 10 -anchor w
    }
    place $a.lab -relx 0 -rely 0 -relwidth $lsiz -relheight 1
    place $a.ent -relx $lsiz -rely 0 -relwidth [expr 1.-$lsiz] -relheight 1
}


menu .topFrame.prog.m
.topFrame.prog.m add cascade -label "Run control" -menu .topFrame.prog.m.runco
.topFrame.prog.m add command -label "Operator" -command { exec $edt \
	$env(USERUNIDAQ)/conf/operator.tcl }
.topFrame.prog.m add cascade -label "Collector" -menu .topFrame.prog.m.coll
.topFrame.prog.m add command -label "Dataview" -command { exec $edt \
	$env(USERUNIDAQ)/conf/dataview.tcl }
.topFrame.prog.m add command -label "uni_config" -command { exec $edt \
	$env(USERUNIDAQ)/conf/uni_config.tcl }

menu .topFrame.prog.m.runco
.topFrame.prog.m.runco add command -label "command.list" -command { \
	remlink $env(USERUNIDAQ)/conf/command.list ; \
	exec $edt $env(USERUNIDAQ)/conf/command.list }
.topFrame.prog.m.runco add command -label "commands.h" -command { \
	remlink $env(TOPUNIDAQ)/src/control/runcontrol/commands.h ; \
	exec $edt $env(TOPUNIDAQ)/src/control/runcontrol/commands.h }
.topFrame.prog.m.runco add command -label "commands_lib.c" -command { \
	remlink $env(TOPUNIDAQ)/src/control/runcontrol/commands_lib.c ; \
	exec $edt $env(TOPUNIDAQ)/src/control/runcontrol/commands_lib.c }
.topFrame.prog.m.runco add command -label "make" -command { \
 puts [ exec $env(USERUNIDAQ)/conf/tcl_make \
                   $env(TOPUNIDAQ)/src/control/runcontrol clean] ; \
 puts [ exec $env(USERUNIDAQ)/conf/tcl_make \
                   $env(TOPUNIDAQ)/src/control/runcontrol ] }

menu .topFrame.prog.m.coll
.topFrame.prog.m.coll add command -label "User Code" -command { \
	remlink $env(USERUNIDAQ)/collector/user_event.c ; \
	exec $edt $env(USERUNIDAQ)/collector/user_event.c }
.topFrame.prog.m.coll add command -label "Pseudo Code" -command { \
	remlink $env(USERUNIDAQ)/collector/pseudo_event.c ; \
	exec $edt $env(USERUNIDAQ)/collector/pseudo_event.c }
.topFrame.prog.m.coll add command -label "Main Collector" -command { \
	remlink $env(USERUNIDAQ)/collector/collector.c ; \
	exec $edt $env(USERUNIDAQ)/collector/collector.c }
.topFrame.prog.m.coll add command -label "make" -command { \
 puts [ exec $env(USERUNIDAQ)/conf/tcl_make \
                   $env(USERUNIDAQ)/collector clean] ; \
 puts [ exec $env(USERUNIDAQ)/conf/tcl_make \
                   $env(USERUNIDAQ)/collector ] }

place .topFrame.msg       -relx 0.  -rely 0.  -relwidth 1.  -relheight .4
place .topFrame.msg1      -relx 0.  -rely .4  -relwidth 1.  -relheight .4
place .topFrame.net       -relx .00  -rely .8  -relwidth .25  -relheight .2
place .topFrame.prog      -relx .25  -rely .8  -relwidth .25  -relheight .2
place .topFrame.edt       -relx .50  -rely .8  -relwidth .25  -relheight .2
place .topFrame.butExit   -relx .75  -rely .8  -relwidth .25  -relheight .2
	     

place .topFrame -relx 0. -rely 0. -relwidth 1. -relheight 1.

proc remlink { name } {
 set lnam [exec ls -l $name]
 set lnam [lindex $lnam 0]
 if { [string match "lr*" $lnam] == 1 } {
	exec cp $name $name.temp
	exec rm $name
	exec mv $name.temp $name
 } 
}

proc ask_editor { } {
 global edt

 label .topFrame.edlab -text "Editor >>" -background blue -foreground white
 entry .topFrame.edent -textvariable edt -background white -foreground black

 bind .topFrame.edent <KeyPress-Return> { \
 destroy .topFrame.edlab ; destroy .topFrame.edent }
 place .topFrame.edlab -relx 0. -rely .8 -relwidth .2 -relheight .2
 place .topFrame.edent -relx .2 -rely .8 -relwidth .8 -relheight .2
}
